// Playground - noun: a place where people can play

import UIKit

///////////////////////////////////
//
// 4-2 Optional型
//
///////////////////////////////////

// 4-2-1 Optional型とは

// 定義を見るにはOptionalをcmd + click
let optional:Optional<Int> = 1

let str1     = "100"
let number1  = str1.toInt()
let str2     = "abc"
let number2  = str2.toInt()

let i:Int?
// let i:Optional<Int> // と同義

// 4-2-2 nilの代入
let optionalStr:String? = nil
// let str:String = nil // コンパイルエラー

// 4-3-3 Optional型への代入
var optionalNumber:Int? = 100

var number = 200
optionalNumber = number

// 4-2-4 アンラップ
if optionalNumber != nil {
    number = optionalNumber!
    print("number is \(number)")
}

// 4-2-5 Optional Binding

var str = "100"
if let strNumber = str.toInt() {
    println("number is \(strNumber)")
}

// 複数のOptional Binding
var priceStr1 = "1000"
var priceStr2 = "500"
if let price1 = priceStr1.toInt() {
    if let price2 = priceStr2.toInt() {
        println("total price is \(price1 + price2)")
    }
}

// Switchでの代用
switch (priceStr1.toInt(), priceStr2.toInt()) {
case (.Some(let price1), .Some(let price2)) :
    println("total price is \(price1 + price2)")
default: break
}

// 4-2-6 ?? 演算子
str = "100"
number = str.toInt() ?? 0

var s1 = "non number"
var s2 = "100"

number = s1.toInt() ?? s2.toInt() ?? 0

